//----------------------------------------------------------------------------
#ifndef TCompareDialogH
#define TCompareDialogH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <Grids.hpp>
#include "TCompareOptions.h"
//----------------------------------------------------------------------------
class TCompareDialog : public TForm
{
__published:
	TGroupBox *GroupBox1;
	TLabel *Label11;
	TLabel *Label12;
	TEdit *Edit11;
	TEdit *Edit12;
	TButton *Button11;
	TButton *Button12;
	TCheckBox *CheckBox11;
	TCheckBox *CheckBox12;
	TCheckBox *CheckBox13;
	TEdit *Edit13;
	TEdit *Edit14;
	TGroupBox *GroupBox2;
	TCheckBox *CheckBox21;
	TGroupBox *GroupBox3;
	TCheckBox *CheckBox31;
	TButton *Button1;
	TButton *Button2;
	TButton *Button3;
	TButton *Button4;
	TButton *Button5;
	TButton *Button6;
	void __fastcall FormShow(TObject* ASender);
	void __fastcall FormActivate(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall CheckBoxClick(TObject* ASender);
	void __fastcall Button11Click(TObject* ASender);
	void __fastcall Button12Click(TObject* ASender);
	void __fastcall Button3Click(TObject* ASender);
	void __fastcall Button4Click(TObject* ASender);
	void __fastcall Button5Click(TObject* ASender);
	void __fastcall Button6Click(TObject* ASender);
public:
	enum {
		SELECTFILE_SRC_DIR,
		SELECTFILE_DST_DIR,
		SELECTFILE_IMPORT,
		SELECTFILE_EXPORT,
	};
	enum {
		FILEACCESS_IMPORT,
		FILEACCESS_EXPORT,
	};
	typedef void __fastcall (__closure* TSelectFileEvent)(TObject* ASender,
		AnsiString& AFileName, int AId, bool& ASelected);
	typedef void __fastcall (__closure* TFileAccessEvent)(TObject* ASender,
		AnsiString AFileName, int AId);
private:
	AnsiString FFileName;
	TCompareOptions FOptions;
	TSelectFileEvent FOnSelectFile;
	TFileAccessEvent FOnFileAccess;
	struct {
		TCompareOptions Options;
	} FBackup;
	void __fastcall SelectDir(int AId);
protected:
	void __fastcall ReflectParams();
	bool __fastcall UpdateParams();
	bool __fastcall ImportParams(AnsiString AFileName);
	bool __fastcall ExportParams(AnsiString AFileName);
	void __fastcall BackupParams();
	void __fastcall RestoreParams();
	void __fastcall UpdateEnabled();
	void __fastcall ActivateControl(TWinControl* AControl);
	void __fastcall SetOptions(TCompareOptions AOptions);
	void __fastcall OptionsChange();
	void __fastcall ReflectOptions();
	bool __fastcall UpdateOptions();
	bool __fastcall DoSelectFile(AnsiString& AFileName, int AId);
	void __fastcall DoFileAccess(AnsiString AFileName, int AId);
	void __fastcall FilesDrop(const TStrings* AFiles);
	void __fastcall WMDropFiles(TWMDropFiles& AMessage);
public:
	virtual __fastcall TCompareDialog(TComponent* AOwner);
	virtual __fastcall ~TCompareDialog();
	bool __fastcall Execute(AnsiString AFileName);
	__property TCompareOptions Options = {read=FOptions, write=SetOptions};
	__property TSelectFileEvent OnSelectFile = {read=FOnSelectFile,
		write=FOnSelectFile};
	__property TFileAccessEvent OnFileAccess = {read=FOnFileAccess,
		write=FOnFileAccess};
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
	END_MESSAGE_MAP(TForm)
};
//----------------------------------------------------------------------------
extern PACKAGE TCompareDialog* CompareDialog;
//----------------------------------------------------------------------------
#endif
