//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TCompareItem.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// internal
//---------------------------------------------------------------------------
namespace
{
const __int64 ONE_DAY = static_cast<__int64>(24) * 60 * 60 * 1000 * 1000 * 10;
} // end of namespace
//---------------------------------------------------------------------------
// external
//---------------------------------------------------------------------------
// struct TCompareItem
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
__int64 __fastcall TCompareItem::GetTimeRemInDays() const
{
	return ((TimeRem + (ONE_DAY - 1) * (TimeRem < 0 ? -1 : 1)) / ONE_DAY);
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TCompareItem::TCompareItem() :
	SrcName(),
	DstName(),
	SizeRem(0),
	TimeRem(0),
	Duplicates(false),
	Result(RESULT_NONE)
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TCompareItem::TCompareItem(const TCompareItem& ASrc) :
	SrcName(),
	DstName(),
	SizeRem(),
	TimeRem(),
	Duplicates(false),
	Result(RESULT_NONE)
{
	*this = ASrc;
}
//---------------------------------------------------------------------------
__fastcall TCompareItem::~TCompareItem()
{
	// do nothing
}
//---------------------------------------------------------------------------
TCompareItem& __fastcall TCompareItem::operator=(const TCompareItem& ASrc)
{
	if(&ASrc != this) {
		SrcName = ASrc.SrcName;
		DstName = ASrc.DstName;
		SizeRem = ASrc.SizeRem;
		TimeRem = ASrc.TimeRem;
		Duplicates = ASrc.Duplicates;
		Result = ASrc.Result;
	}
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TCompareItem::operator==(const TCompareItem& ASrc) const
{
	return
		SrcName == ASrc.SrcName &&
		DstName == ASrc.DstName &&
		TimeRem == ASrc.TimeRem &&
		Duplicates == ASrc.Duplicates &&
		Result == ASrc.Result;
}
//---------------------------------------------------------------------------
bool __fastcall TCompareItem::operator!=(const TCompareItem& ASrc) const
{
	return !(*this == ASrc);
}
//---------------------------------------------------------------------------
