//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TCompareLoader.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// internal
//---------------------------------------------------------------------------
namespace
{
const AnsiString ABOUT_FILETYPE = "Step Backupper Compare";
const int ABOUT_MAJORVERSION = 1;
const int ABOUT_MINORVERSION = 0;
const AnsiString INI_ABOUT = "About";
const AnsiString INI_ABOUT_FILETYPE = "FileType";
const AnsiString INI_ABOUT_MAJORVERSION = "MajorVersion";
const AnsiString INI_ABOUT_MINORVERSION = "MinorVersion";
const AnsiString INI_OPTIONS = "Options";
const AnsiString INI_OPTIONS_SRCDIR = "SrcDir";
const AnsiString INI_OPTIONS_DSTDIR = "DstDir";
const AnsiString INI_OPTIONS_USEINCLUDEMASKS = "UseIncludeMasks";
const AnsiString INI_OPTIONS_INCLUDEMASKS = "IncludeMasks";
const AnsiString INI_OPTIONS_USEEXCLUDEMASKS = "UseExcludeMasks";
const AnsiString INI_OPTIONS_EXCLUDEMASKS = "ExcludeMasks";
const AnsiString INI_OPTIONS_INCLUDESUBDIRS = "IncludeSubDirs";
const AnsiString INI_OPTIONS_FATPRECISION = "FatPrecision";
const AnsiString INI_OPTIONS_SHOWNOTMODIFIED = "ShowNotModified";
} // end of namespace
//---------------------------------------------------------------------------
// external
//---------------------------------------------------------------------------
// class TCompareLoader
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
__fastcall TCompareLoader::TCompareLoader(const TCompareLoader& ASrc) :
	FOptions()
{
	throw 0;
}
//---------------------------------------------------------------------------
TCompareLoader& __fastcall TCompareLoader::operator=(
	const TCompareLoader& ASrc)
{
	throw 0;
}
//---------------------------------------------------------------------------
bool __fastcall TCompareLoader::operator==(const TCompareLoader& ASrc) const
{
	throw 0;
}
//---------------------------------------------------------------------------
bool __fastcall TCompareLoader::operator!=(const TCompareLoader& ASrc) const
{
	throw 0;
}
//---------------------------------------------------------------------------
void __fastcall TCompareLoader::LoadAbout(TMemIniFile* AParams)
{
	FAbout.FileType = AParams->ReadString(
		INI_ABOUT, INI_ABOUT_FILETYPE, "");
	FAbout.MajorVersion = AParams->ReadInteger(
		INI_ABOUT, INI_ABOUT_MAJORVERSION, -1);
	FAbout.MinorVersion = AParams->ReadInteger(
		INI_ABOUT, INI_ABOUT_MINORVERSION, -1);
}
//---------------------------------------------------------------------------
void __fastcall TCompareLoader::SaveAbout(TMemIniFile* AParams)
{
	AParams->WriteString(
		INI_ABOUT, INI_ABOUT_FILETYPE, ABOUT_FILETYPE);
	AParams->WriteInteger(
		INI_ABOUT, INI_ABOUT_MAJORVERSION, ABOUT_MAJORVERSION);
	AParams->WriteInteger(
		INI_ABOUT, INI_ABOUT_MINORVERSION, ABOUT_MINORVERSION);
}
//---------------------------------------------------------------------------
void __fastcall TCompareLoader::LoadOptions(TMemIniFile* AParams)
{
	TCompareOptions options;
	options.SrcDir = AParams->ReadString(
		INI_OPTIONS, INI_OPTIONS_SRCDIR, options.SrcDir);
	options.DstDir = AParams->ReadString(
		INI_OPTIONS, INI_OPTIONS_DSTDIR, options.DstDir);
	options.UseIncludeMasks = AParams->ReadBool(
		INI_OPTIONS, INI_OPTIONS_USEINCLUDEMASKS, options.UseIncludeMasks);
	options.IncludeMasks = AParams->ReadString(
		INI_OPTIONS, INI_OPTIONS_INCLUDEMASKS, options.IncludeMasks);
	options.UseExcludeMasks = AParams->ReadBool(
		INI_OPTIONS, INI_OPTIONS_USEEXCLUDEMASKS, options.UseExcludeMasks);
	options.ExcludeMasks = AParams->ReadString(
		INI_OPTIONS, INI_OPTIONS_EXCLUDEMASKS, options.ExcludeMasks);
	options.IncludeSubDirs = AParams->ReadBool(
		INI_OPTIONS, INI_OPTIONS_INCLUDESUBDIRS, options.IncludeSubDirs);
	options.FatPrecision = AParams->ReadBool(
		INI_OPTIONS, INI_OPTIONS_FATPRECISION, options.FatPrecision);
	options.ShowNotModified = AParams->ReadBool(
		INI_OPTIONS, INI_OPTIONS_SHOWNOTMODIFIED, options.ShowNotModified);
	Options = options;
}
//---------------------------------------------------------------------------
void __fastcall TCompareLoader::SaveOptions(TMemIniFile* AParams)
{
	TCompareOptions options = Options;
	AParams->WriteString(
		INI_OPTIONS, INI_OPTIONS_SRCDIR, options.SrcDir);
	AParams->WriteString(
		INI_OPTIONS, INI_OPTIONS_DSTDIR, options.DstDir);
	AParams->WriteBool(
		INI_OPTIONS, INI_OPTIONS_USEINCLUDEMASKS, options.UseIncludeMasks);
	AParams->WriteString(
		INI_OPTIONS, INI_OPTIONS_INCLUDEMASKS, options.IncludeMasks);
	AParams->WriteBool(
		INI_OPTIONS, INI_OPTIONS_USEEXCLUDEMASKS, options.UseExcludeMasks);
	AParams->WriteString(
		INI_OPTIONS, INI_OPTIONS_EXCLUDEMASKS, options.ExcludeMasks);
	AParams->WriteBool(
		INI_OPTIONS, INI_OPTIONS_INCLUDESUBDIRS, options.IncludeSubDirs);
	AParams->WriteBool(
		INI_OPTIONS, INI_OPTIONS_FATPRECISION, options.FatPrecision);
	AParams->WriteBool(
		INI_OPTIONS, INI_OPTIONS_SHOWNOTMODIFIED, options.ShowNotModified);
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TCompareLoader::TCompareLoader() :
	FOptions()
{
	FAbout.MajorVersion = FAbout.MinorVersion = -1;
	Clear();
}
//---------------------------------------------------------------------------
__fastcall TCompareLoader::~TCompareLoader()
{
	// do nothing
}
//---------------------------------------------------------------------------
void __fastcall TCompareLoader::LoadFromFile(AnsiString AFileName)
{
	TMemIniFile* params = NULL;
	try {
		params = new TMemIniFile(AFileName);
		Clear();
		LoadAbout(params);
		LoadOptions(params);
	}
	__finally {
		delete params;
	}
}
//---------------------------------------------------------------------------
void __fastcall TCompareLoader::SaveToFile(AnsiString AFileName)
{
	TMemIniFile* params = NULL;
	try {
		params = new TMemIniFile(AFileName);
		params->Clear();
		SaveAbout(params);
		SaveOptions(params);
		params->UpdateFile();
	}
	__finally {
		delete params;
	}
}
//---------------------------------------------------------------------------
void __fastcall TCompareLoader::Clear()
{
	FAbout.FileType = ABOUT_FILETYPE;
	FAbout.MajorVersion = ABOUT_MAJORVERSION;
	FAbout.MinorVersion = ABOUT_MINORVERSION;
	Options = TCompareOptions();
}
//---------------------------------------------------------------------------
bool __fastcall TCompareLoader::IsSupported() const
{
	bool supported = false;
	for(;;) {
		if(!AnsiSameText(FAbout.FileType, ABOUT_FILETYPE)) {
			break;
		}
		if(FAbout.MajorVersion > ABOUT_MAJORVERSION ||
			FAbout.MajorVersion < 0) {
			break;
		}
		if(FAbout.MinorVersion > ABOUT_MINORVERSION ||
			FAbout.MinorVersion < 0) {
			break;
		}
		supported = true;
		break;
	}
	return supported;
}
//---------------------------------------------------------------------------
