//---------------------------------------------------------------------------
#ifndef TCompareLoaderH
#define TCompareLoaderH
#include <Classes.hpp>
#include <IniFiles.hpp>
#include "TCompareOptions.h"
//---------------------------------------------------------------------------
class TCompareLoader
{
private:
	struct {
		AnsiString FileType;
		int MajorVersion;
		int MinorVersion;
	} FAbout;
	TCompareOptions FOptions;
	__fastcall TCompareLoader(const TCompareLoader& ASrc);
	TCompareLoader& __fastcall operator=(const TCompareLoader& ASrc);
	bool __fastcall operator==(const TCompareLoader& ASrc) const;
	bool __fastcall operator!=(const TCompareLoader& ASrc) const;
	void __fastcall LoadAbout(TMemIniFile* AParams);
	void __fastcall SaveAbout(TMemIniFile* AParams);
	void __fastcall LoadOptions(TMemIniFile* AParams);
	void __fastcall SaveOptions(TMemIniFile* AParams);
protected:
public:
	__fastcall TCompareLoader();
	virtual __fastcall ~TCompareLoader();
	void __fastcall LoadFromFile(AnsiString AFileName);
	void __fastcall SaveToFile(AnsiString AFileName);
	void __fastcall Clear();
	bool __fastcall IsSupported() const;
	__property TCompareOptions Options = {read=FOptions, write=FOptions};
};
//---------------------------------------------------------------------------
#endif
