//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TCompareOptions.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// struct TCompareOptions
//---------------------------------------------------------------------------
__fastcall TCompareOptions::TCompareOptions() :
	SrcDir(),
	DstDir(),
	UseIncludeMasks(false),
	IncludeMasks("*"),
	UseExcludeMasks(false),
	ExcludeMasks("*"),
	IncludeSubDirs(true),
	FatPrecision(true),
	ShowNotModified(false)
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TCompareOptions::TCompareOptions(const TCompareOptions& ASrc) :
	SrcDir(),
	DstDir(),
	UseIncludeMasks(false),
	IncludeMasks("*"),
	UseExcludeMasks(false),
	ExcludeMasks("*"),
	IncludeSubDirs(true),
	FatPrecision(true),
	ShowNotModified(false)
{
	*this = ASrc;
}
//---------------------------------------------------------------------------
__fastcall TCompareOptions::~TCompareOptions()
{
	// do nothing
}
//---------------------------------------------------------------------------
TCompareOptions& __fastcall TCompareOptions::operator=(
	const TCompareOptions& ASrc)
{
	if(&ASrc != this) {
		SrcDir = ASrc.SrcDir;
		DstDir = ASrc.DstDir;
		UseIncludeMasks = ASrc.UseIncludeMasks;
		IncludeMasks = ASrc.IncludeMasks;
		UseExcludeMasks = ASrc.UseExcludeMasks;
		ExcludeMasks = ASrc.ExcludeMasks;
		IncludeSubDirs = ASrc.IncludeSubDirs;
		FatPrecision = ASrc.FatPrecision;
		ShowNotModified = ASrc.ShowNotModified;
	}
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TCompareOptions::operator==(const TCompareOptions& ASrc) const
{
	return
		SrcDir == ASrc.SrcDir &&
		DstDir == ASrc.DstDir &&
		UseIncludeMasks == ASrc.UseIncludeMasks &&
		IncludeMasks == ASrc.IncludeMasks &&
		UseExcludeMasks == ASrc.UseExcludeMasks &&
		ExcludeMasks == ASrc.ExcludeMasks &&
		IncludeSubDirs == ASrc.IncludeSubDirs &&
		FatPrecision == ASrc.FatPrecision &&
		ShowNotModified == ASrc.ShowNotModified;
}
//---------------------------------------------------------------------------
bool __fastcall TCompareOptions::operator!=(const TCompareOptions& ASrc) const
{
	return !(*this == ASrc);
}
//---------------------------------------------------------------------------
