//---------------------------------------------------------------------------
#ifndef TCompareThreadH
#define TCompareThreadH
#include <Classes.hpp>
#include "TReportThread.h"
#include "TCompareItem.h"
#include "TCompareOptions.h"
//---------------------------------------------------------------------------
class TCompareThread : public TReportThread
{
private:
	TCompareOptions FOptions;
	TList* FItems;
	TStrings* FIncludeMasks;
	TStrings* FExcludeMasks;
	static bool __fastcall IsFileFound(HANDLE AHandle);
	static bool __fastcall IsRelativeDir(const WIN32_FIND_DATA& AData);
	static bool __fastcall IsDirectory(const WIN32_FIND_DATA& AData);
	static __int64 __fastcall MakeSize(const WIN32_FIND_DATA& AData);
	static __int64 __fastcall MakeSizeRem(__int64 AValue1,
		__int64 AValue2);
	static __int64 __fastcall MakeTime(const WIN32_FIND_DATA& AData);
	static __int64 __fastcall MakeTimeRem(__int64 AValue1, __int64 AValue2,
		bool AFatPrecision);
	static __int64 __fastcall MakeFatTime(__int64 AValue);
	static int __fastcall MakeResult(__int64 ASizeRem, __int64 ATimeRem);
	static void __fastcall StrToMasks(AnsiString AStr, TStrings* AMasks);
	static int __fastcall CompareItem(void* AItem1, void* AItem2);
	void __fastcall PrepareMasks();
	void __fastcall EnumFiles();
	void __fastcall EnumFiles(AnsiString ADir);
	bool __fastcall FilterByName(AnsiString AFileName) const;
	bool __fastcall MatchByName(AnsiString AFileName,
		const TStrings* AMasks) const;
	void __fastcall CompareFiles();
	void __fastcall CompareFile(TCompareItem& AItem);
	bool __fastcall FilterByResult(int AResult) const;
	void __fastcall SortItems();
	__property TLogEvent OnLog = {read=FOnLog, write=FOnLog};
protected:
	virtual void __fastcall Prepare();
	virtual void __fastcall Process();
	virtual void __fastcall Unprepare();
public:
	__fastcall TCompareThread(TCompareOptions AOptions);
	__property TList* Items = {read=FItems};
};
//---------------------------------------------------------------------------
#endif
