//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TFileHistory.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TFileHistory : public TObject
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
__fastcall TFileHistory::TFileHistory(const TFileHistory& ASrc) :
	FItems(NULL),
	FCapacity(0),
	FUpdateCount(0),
	FOnChange(NULL)
{
	throw 0;
}
//---------------------------------------------------------------------------
TFileHistory& __fastcall TFileHistory::operator=(const TFileHistory& ASrc)
{
	throw 0;
}
//---------------------------------------------------------------------------
bool __fastcall TFileHistory::operator==(const TFileHistory& ASrc) const
{
	throw 0;
}
//---------------------------------------------------------------------------
bool __fastcall TFileHistory::operator!=(const TFileHistory& ASrc) const
{
	throw 0;
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::FItemsChange(TObject* ASender)
{
	if(FUpdateCount <= 0) {
		DoChange();
	}
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
void __fastcall TFileHistory::SetCapacity(int ACapacity)
{
	if(ACapacity != FCapacity) {
		FCapacity = ACapacity;
		CapacityChange();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::CapacityChange()
{
	if(Count > Capacity) {
		try {
			BeginUpdate();
			Count = Capacity;
		}
		__finally {
			EndUpdate();
		}
	}
}
//---------------------------------------------------------------------------
int __fastcall TFileHistory::GetCount() const
{
	return FItems->Count;
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::SetCount(int ACount)
{
	if(ACount != Count) {
		try {
			BeginUpdate();
			while(Count > ACount) {
				Delete(Count - 1);
			}
			while(Count < ACount && Count < Capacity) {
				Insert(Count, "");
			}
		}
		__finally {
			EndUpdate();
		}
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFileHistory::GetItem(int AIndex) const
{
	return FItems->Strings[AIndex];
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::SetItem(int AIndex, AnsiString AItem)
{
	FItems->Strings[AIndex] = AItem;
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::SetUpdateCount(int AUpdateCount)
{
	int updateCount = AUpdateCount;
	if(updateCount < 0) {
		updateCount = 0;
	}
	if(updateCount != FUpdateCount) {
		FUpdateCount = updateCount;
		UpdateCountChange();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::UpdateCountChange()
{
	if(FUpdateCount <= 0) {
		DoChange();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::DoChange()
{
	if(OnChange != NULL) {
		OnChange(this);
	}
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TFileHistory::TFileHistory() :
	FItems(new TStringList()),
	FCapacity(0),
	FUpdateCount(0),
	FOnChange(NULL)
{
	FItems->OnChange = FItemsChange;
	CapacityChange();
	UpdateCountChange();
}
//---------------------------------------------------------------------------
__fastcall TFileHistory::~TFileHistory()
{
	FOnChange = NULL;
	FItems->OnChange = NULL;
	delete FItems; FItems = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::Add(AnsiString AItem)
{
	try {
		BeginUpdate();
		int index = Find(AItem);
		if(index >= 0) {
			Delete(index);
		}
		Insert(0, AItem);
	}
	__finally {
		EndUpdate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::Insert(int AIndex, AnsiString AItem)
{
	try {
		BeginUpdate();
		FItems->Insert(AIndex, AItem);
		while(Count > Capacity) {
			Delete(Count - 1);
		}
	}
	__finally {
		EndUpdate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::Delete(int AIndex)
{
	FItems->Delete(AIndex);
}
//---------------------------------------------------------------------------
int __fastcall TFileHistory::Find(AnsiString AItem) const
{
	int index = -1;
	for(int i = 0; i < Count; i++) {
		if(SameFileName(Items[i], AItem)) {
			index = i;
			break;
		}
	}
	return index;
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::Pack()
{
	try {
		BeginUpdate();
		for(int i = 0; i < Count; i++) {
			if(Items[i].Length() <= 0) {
				Delete(i--);
			}
		}
	}
	__finally {
		EndUpdate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::Clear()
{
	Count = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::CopyFrom(const TFileHistory* ASrc)
{
	FItems->Assign(ASrc->FItems);
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::BeginUpdate()
{
	SetUpdateCount(FUpdateCount + 1);
}
//---------------------------------------------------------------------------
void __fastcall TFileHistory::EndUpdate()
{
	SetUpdateCount(FUpdateCount - 1);
}
//---------------------------------------------------------------------------
