//---------------------------------------------------------------------------
#ifndef TFileHistoryH
#define TFileHistoryH
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TFileHistory : public TObject
{
private:
	TStringList* FItems;
	int FCapacity;
	int FUpdateCount;
	TNotifyEvent FOnChange;
	__fastcall TFileHistory(const TFileHistory& ASrc);
	TFileHistory& __fastcall operator=(const TFileHistory& ASrc);
	bool __fastcall operator==(const TFileHistory& ASrc) const;
	bool __fastcall operator!=(const TFileHistory& ASrc) const;
	void __fastcall FItemsChange(TObject* ASender);
protected:
	void __fastcall SetCapacity(int ACapacity);
	void __fastcall CapacityChange();
	int __fastcall GetCount() const;
	void __fastcall SetCount(int ACount);
	AnsiString __fastcall GetItem(int AIndex) const;
	void __fastcall SetItem(int AIndex, AnsiString AItem);
	void __fastcall SetUpdateCount(int AUpdateCount);
	void __fastcall UpdateCountChange();
	void __fastcall DoChange();
public:
	__fastcall TFileHistory();
	virtual __fastcall ~TFileHistory();
	void __fastcall Add(AnsiString AItem);
	void __fastcall Insert(int AIndex, AnsiString AItem);
	void __fastcall Delete(int AIndex);
	int __fastcall Find(AnsiString AItem) const;
	void __fastcall Pack();
	void __fastcall Clear();
	void __fastcall CopyFrom(const TFileHistory* ASrc);
	void __fastcall BeginUpdate();
	void __fastcall EndUpdate();
	__property AnsiString Items[int AIndex] = {read=GetItem, write=SetItem};
	__property int Count = {read=GetCount, write=SetCount};
	__property int Capacity = {read=FCapacity, write=SetCapacity};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
#endif
