//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TFindItemDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFindItemDialog* FindItemDialog = NULL;
//---------------------------------------------------------------------------
// __published:
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::FormShow(TObject* ASender)
{
	ReflectParams();
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::FormCloseQuery(TObject* ASender,
	bool& ACanClose)
{
	bool canClose = true;
	if(ModalResult == Button1->ModalResult ||
		ModalResult == Button2->ModalResult) {
		if(!UpdateParams()) {
			canClose = false;
		}
	}
	ACanClose = canClose;
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::Edit1Change(TObject* ASender)
{
	UpdateEnabled();
}
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
int __fastcall TFindItemDialog::DownToIndex(bool ADown)
{
	return ADown ? 1 : 0;
}
//---------------------------------------------------------------------------
bool __fastcall TFindItemDialog::IndexToDown(int AIndex)
{
	return AIndex == 1;
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::ReflectParams()
{
	ReflectOptions();
}
//---------------------------------------------------------------------------
bool __fastcall TFindItemDialog::UpdateParams()
{
	return UpdateOptions();
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::BackupParams()
{
	FBackup.Options = Options;
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::RestoreParams()
{
	Options = FBackup.Options;
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::UpdateEnabled()
{
	Button1->Enabled = Edit1->Text.Length() > 0;
	Button2->Enabled = Button1->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::SetOptions(TFindItemOptions AOptions)
{
	if(AOptions != FOptions) {
		FOptions = AOptions;
		OptionsChange();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::OptionsChange()
{
	ReflectOptions();
}
//---------------------------------------------------------------------------
void __fastcall TFindItemDialog::ReflectOptions()
{
	TFindItemOptions options = Options;
	Edit1->Text = options.FindText;
	CheckBox1->Checked = options.MatchAbsoluteName;
	RadioGroup1->ItemIndex = DownToIndex(options.Down);
	UpdateEnabled();
}
//---------------------------------------------------------------------------
bool __fastcall TFindItemDialog::UpdateOptions()
{
	TFindItemOptions options;
	options.FindText = Edit1->Text;
	options.MatchAbsoluteName = CheckBox1->Checked;
	options.Down = DownToIndex(RadioGroup1->ItemIndex);
	options.FindAll = ModalResult == Button2->ModalResult;
	Options = options;
	return true;
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TFindItemDialog::TFindItemDialog(TComponent* AOwner) :
	TForm(AOwner),
	FOptions(),
	FBackup()
{
	OptionsChange();
}
//---------------------------------------------------------------------------
__fastcall TFindItemDialog::~TFindItemDialog()
{
	// do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TFindItemDialog::Execute()
{
	bool ok = false;
	{
		BackupParams();
	}
	ShowModal();
	if(ModalResult == Button1->ModalResult ||
		ModalResult == Button2->ModalResult) {
		ok = true;
	}
	if(!ok) {
		RestoreParams();
	}
	return ok;
}
//---------------------------------------------------------------------------

