//---------------------------------------------------------------------------
#ifndef TMessageDialogH
#define TMessageDialogH
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TMessageDialog
{
public:
	enum {
		ICONTYPE_WARNING,
		ICONTYPE_ERROR,
		ICONTYPE_INFORMATION,
		ICONTYPE_CONFIRMATION,
		ICONTYPE_CUSTOM,
		ICONTYPE_OTHER,
	};
private:
	AnsiString FCaption;
	AnsiString FMessage;
	TStrings* FButtonCaptions;
	int FDefaultButton;
	int FCancelButton;
	int FIconType;
	TIcon* FIcon;
	int FResultButton;
	__fastcall TMessageDialog(const TMessageDialog& ASrc);
	TMessageDialog& __fastcall operator=(const TMessageDialog& ASrc);
	bool __fastcall operator==(const TMessageDialog& ASrc) const;
	bool __fastcall operator!=(const TMessageDialog& ASrc) const;
	TForm* __fastcall MakeForm() const;
	TMsgDlgType __fastcall MakeMsgDlgType() const;
	TMsgDlgButtons __fastcall MakeMsgDlgButtons() const;
	void __fastcall InitButtons(TForm* AForm) const;
	static void __fastcall EnumControls(TList* AControls, TForm* AForm,
		TClass AClass);
	static int __fastcall CompareButton(void* AItem1, void* AItem2);
	static void __fastcall EnableCloseButton(TForm* AForm, bool AEnabled);
	void __fastcall InitIcon(TForm* AForm) const;
	void __fastcall FormCloseQuery(TObject* AObject, bool& ACanClose);
	void __fastcall ButtonClick(TObject* AObject);
protected:
public:
	__fastcall TMessageDialog();
	virtual __fastcall ~TMessageDialog();
	int __fastcall Execute();
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property AnsiString Message = {read=FMessage, write=FMessage};
	__property TStrings* ButtonCaptions = {read=FButtonCaptions};
	__property int DefaultButton = {read=FDefaultButton, write=FDefaultButton};
	__property int CancelButton = {read=FCancelButton, write=FCancelButton};
	__property int IconType = {read=FIconType, write=FIconType};
	__property TIcon* Icon = {read=FIcon};
	__property int ResultButton = {read=FResultButton, write=FResultButton};
};
//---------------------------------------------------------------------------
#endif
