//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TOpenDialogList.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TOpenDialogList : public TList
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
bool __fastcall TOpenDialogList::IsAbsoluteFileName(AnsiString AFileName)
{
	return ExtractFileDrive(AFileName).Length() > 0;
}
//---------------------------------------------------------------------------
TOpenDialog* __fastcall TOpenDialogList::GetItem(int AIndex)
{
	return static_cast<TOpenDialog*>(TList::Items[AIndex]);
}
//---------------------------------------------------------------------------
void __fastcall TOpenDialogList::SetItem(int AIndex, TOpenDialog* AItem)
{
	TList::Items[AIndex] = AItem;
}
//---------------------------------------------------------------------------
TOpenDialog** __fastcall TOpenDialogList::GetList() const
{
	return reinterpret_cast<TOpenDialog**>(TList::List);
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TOpenDialogList::TOpenDialogList() :
	TList(),
	FInitialDir()
{
	// do nothing
}
//---------------------------------------------------------------------------
int __fastcall TOpenDialogList::Add(TOpenDialog* AItem)
{
	return TList::Add(AItem);
}
//---------------------------------------------------------------------------
void __fastcall TOpenDialogList::Assign(TOpenDialogList* AListA,
	TListAssignOp AOperator, TOpenDialogList* AListB)
{
	TList::Assign(AListA, AOperator, AListB);
}
//---------------------------------------------------------------------------
TOpenDialogList* __fastcall TOpenDialogList::Expand()
{
	return static_cast<TOpenDialogList*>(TList::Expand());
}
//---------------------------------------------------------------------------
TOpenDialog* __fastcall TOpenDialogList::Extract(TOpenDialog* AItem)
{
	return static_cast<TOpenDialog*>(TList::Extract(AItem));
}
//---------------------------------------------------------------------------
TOpenDialog* __fastcall TOpenDialogList::First()
{
	return static_cast<TOpenDialog*>(TList::First());
}
//---------------------------------------------------------------------------
int __fastcall TOpenDialogList::IndexOf(TOpenDialog* AItem)
{
	return TList::IndexOf(AItem);
}
//---------------------------------------------------------------------------
void __fastcall TOpenDialogList::Insert(int AIndex, TOpenDialog* AItem)
{
	TList::Insert(AIndex, AItem);
}
//---------------------------------------------------------------------------
TOpenDialog* __fastcall TOpenDialogList::Last()
{
	return static_cast<TOpenDialog*>(TList::Last());
}
//---------------------------------------------------------------------------
int __fastcall TOpenDialogList::Remove(TOpenDialog* AItem)
{
	return TList::Remove(AItem);
}
//---------------------------------------------------------------------------
bool __fastcall TOpenDialogList::SelectFiles(int AIndex,
	AnsiString& AFileName, TStrings* AFiles)
{
	bool ok = false;
	for(;;) {
		TOpenDialog* dialog = Items[AIndex];
		if(IsAbsoluteFileName(AFileName)) {
			dialog->InitialDir = ExtractFileDir(AFileName);
			dialog->FileName = ExtractFileName(AFileName);
		}
		else {
			dialog->InitialDir = InitialDir;
			dialog->FileName = AFileName;
		}
		if(!dialog->Execute()) {
			break;
		}
		ok = true;
		AFileName = dialog->FileName;
		if(AFiles != NULL) {
			AFiles->Assign(dialog->Files);
		}
		InitialDir = ExtractFileDir(dialog->FileName);
		dialog->FileName = "";
		dialog->Files->Clear();
		break;
	}
	return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TOpenDialogList::SelectDirectory(AnsiString ACaption,
	AnsiString& ADirectory)
{
	bool ok = false;
	for(;;) {
		if(!::SelectDirectory(ACaption, "", ADirectory)) {
			break;
		}
		ok = true;
		InitialDir = ExtractFileDir(ADirectory);
		break;
	}
	return ok;
}
//---------------------------------------------------------------------------
