//----------------------------------------------------------------------------
#ifndef TOperationsDialogH
#define TOperationsDialogH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
//----------------------------------------------------------------------------
class TOperationsDialog : public TForm
{
__published:
	TPopupMenu *PopupMenu1;
	TMenuItem *CopySelectionM1;
	TMenuItem *CopyAllM1;
	TMenuItem *SelectAllM1;
	TMenuItem *SelectNoneM1;
	TMenuItem *InvertSelectionM1;
	TMenuItem *SeparatorM1;
	TPanel *Panel1;
	TLabel *Label1;
	TListBox *ListBox1;
	TPanel *Panel2;
	TProgressBar *ProgressBar1;
	TButton *Button1;
	TButton *Button2;
	TButton *Button3;
	TButton *Button4;
	void __fastcall FormShow(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall FormClose(TObject* ASender, TCloseAction& AAction);
	void __fastcall CopySelectionM1Click(TObject* ASender);
	void __fastcall SelectAllM1Click(TObject* ASender);
	void __fastcall ButtonClick(TObject* ASender);
	void __fastcall OperationsThreadLog(TObject* ASender, AnsiString ALog);
	void __fastcall OperationsThreadProgress(TObject* ASender, int AProcessed,
		int AAll);
	void __fastcall OperationsThreadTerminate(TObject* ASender);
private:
	const TStrings* FFrom;
	const TStrings* FTo;
	TThread* FThread;
protected:
	int __fastcall GetPercentDone() const;
	void __fastcall SetPercentDone(int APercentDone);
public:
	virtual __fastcall TOperationsDialog(TComponent* AOwner);
	virtual __fastcall ~TOperationsDialog();
	void __fastcall Execute(const TStrings* AFrom, const TStrings* ATo);
	void __fastcall AddLog(AnsiString ALog);
	void __fastcall ClearLog();
	void __fastcall CopyLog(TStrings* ALog);
	void __fastcall CopyLogSelection(TStrings* ALog);
	void __fastcall ShowProgress(int AProcessed, int AAll);
	__property int PercentDone = {read=GetPercentDone, write=SetPercentDone};
};
//----------------------------------------------------------------------------
extern PACKAGE TOperationsDialog* OperationsDialog;
//----------------------------------------------------------------------------
#endif   
