//---------------------------------------------------------------------------
#ifndef TOperationsThreadH
#define TOperationsThreadH
#include <Classes.hpp>
#include "TReportThread.h"
//---------------------------------------------------------------------------
class TOperationsThread : public TReportThread
{
public:
	enum {
		OPERATION_MOVE,
		OPERATION_COPY,
		OPERATION_DELETE,
	};
	typedef void __fastcall (__closure* TLogEvent)(TObject* ASender,
		AnsiString ALog);
	typedef void __fastcall (__closure* TProgressEvent)(TObject* ASender,
		int AProcessed, int ACount);
private:
	TStrings* FFrom;
	TStrings* FTo;
	int FOperation;
	TProgressEvent FOnProgress;
	static AnsiString __fastcall DoubleQuoteStr(AnsiString AStr);
	static AnsiString __fastcall ResultToStr(bool ASucceeded);
	static AnsiString __fastcall DoneToStr(int AProcessed, int ACount);
	static bool __fastcall PerformFileOperation(AnsiString AFrom,
		AnsiString ATo, bool ACopy, bool ADelete);
	void __fastcall PerformOperations();
	bool __fastcall PerformMove(AnsiString AFrom, AnsiString ATo);
	bool __fastcall PerformCopy(AnsiString AFrom, AnsiString ATo);
	bool __fastcall PerformDelete(AnsiString ATarget);
protected:
	virtual void __fastcall Execute();
	virtual void __fastcall Prepare();
	virtual void __fastcall Process();
	virtual void __fastcall Unprepare();
public:
	__fastcall TOperationsThread(const TStrings* AFrom, const TStrings* ATo,
		int AOperation);
};
//---------------------------------------------------------------------------
#endif
