//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TProgressDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TProgressDialog* ProgressDialog = NULL;
//---------------------------------------------------------------------------
// __published:
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
	FThread->Resume();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::FormCloseQuery(TObject* ASender,
	bool& ACanClose)
{
	bool canClose = true;
	if(FThread != NULL) {
		FThread->Terminate();
		canClose = false;
	}
	ACanClose = canClose;
}
//---------------------------------------------------------------------------
// private
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
int __fastcall TProgressDialog::GetPercentDone() const
{
	return ProgressBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::SetPercentDone(int APercentDone)
{
	ProgressBar1->Position = APercentDone;
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TProgressDialog::TProgressDialog(TComponent* AOwner) :
	TForm(AOwner),
	FThread(NULL)
{
	// do nothing
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Start(TThread* AThread)
{
	ShowMessage("Processing...");
	PercentDone = 0;
	Button1->Caption = "Cancel";
	FThread = AThread;
	ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Finish(bool ACanClose)
{
	ShowMessage("Done");
	PercentDone = 0;
	Button1->Caption = "OK";
	FThread = NULL;
	if(ACanClose) {
		ModalResult = Button1->ModalResult;
	}
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ShowMessage(AnsiString AMessage)
{
	Label1->Caption = AMessage;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ShowProgress(int AProcessed, int AAll)
{
	int percentDone;
	if(AProcessed <= 0 || AAll <= 0) {
		percentDone = 0;
	}
	else if(AProcessed >= AAll) {
		percentDone = 100;
	}
	else {
		percentDone = static_cast<__int64>(AProcessed) * 100 / AAll;
	}
	PercentDone = percentDone;
}
//---------------------------------------------------------------------------

