//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TReportThread.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TReportThread : public TThread
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
void __fastcall TReportThread::SyncDoLog()
{
	OnLog(this, FLogParams.Log);
}
//---------------------------------------------------------------------------
void __fastcall TReportThread::SyncDoProgress()
{
	OnProgress(this, FProgressParams.Processed, FProgressParams.All);
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
void __fastcall TReportThread::Execute()
{
	try {
		for(;;) {
			Prepare();
			if(Terminated) {
				Canceled = true;
				break;
			}
			Process();
			if(Terminated) {
				Stopped = true;
				break;
			}
			break;
		}
	}
	catch(...) {
		Error = true;
	}
}
//---------------------------------------------------------------------------
void __fastcall TReportThread::DoTerminate()
{
	TThread::DoTerminate();
	Unprepare();
}
//---------------------------------------------------------------------------
void __fastcall TReportThread::DoLog(AnsiString ALog)
{
	if(OnLog != NULL) {
		FLogParams.Log = ALog;
		Synchronize(SyncDoLog);
	}
}
//---------------------------------------------------------------------------
void __fastcall TReportThread::DoProgress(int AProcessed, int AAll)
{
	if(OnProgress != NULL) {
		FProgressParams.Processed = AProcessed;
		FProgressParams.All = AAll;
		Synchronize(SyncDoProgress);
	}
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TReportThread::TReportThread(bool ACreateSuspended) :
	TThread(ACreateSuspended),
	FCanceled(false),
	FStopped(false),
	FError(false),
	FOnLog(NULL),
	FLogParams(),
	FOnProgress(NULL),
	FProgressParams()
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TReportThread::~TReportThread()
{
	// do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TReportThread::IsFinished() const
{
	return !Canceled && !Stopped;
}
//---------------------------------------------------------------------------
