//---------------------------------------------------------------------------
#ifndef TReportThreadH
#define TReportThreadH
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TReportThread : public TThread
{
public:
	typedef void __fastcall (__closure* TLogEvent)(TObject* ASender,
		AnsiString ALog);
	typedef void __fastcall (__closure* TProgressEvent)(TObject* ASender,
		int AProcessed, int AAll);
private:
	bool FCanceled;
	bool FStopped;
	bool FError;
	TLogEvent FOnLog;
	struct {
		AnsiString Log;
	} FLogParams;
	TProgressEvent FOnProgress;
	struct {
		int Processed;
		int All;
	} FProgressParams;
	void __fastcall SyncDoLog();
	void __fastcall SyncDoProgress();
protected:
	virtual void __fastcall Execute();
	virtual void __fastcall Prepare() = 0;
	virtual void __fastcall Process() = 0;
	virtual void __fastcall Unprepare() = 0;
	virtual void __fastcall DoTerminate();
	virtual void __fastcall DoLog(AnsiString ALog);
	virtual void __fastcall DoProgress(int AProcessed, int AAll);
public:
	__fastcall TReportThread(bool ACreateSuspended);
	virtual __fastcall ~TReportThread();
	bool __fastcall IsFinished() const;
	__property bool Canceled = {read=FCanceled, write=FCanceled};
	__property bool Stopped = {read=FStopped, write=FStopped};
	__property bool Error = {read=FError, write=FError};
	__property TLogEvent OnLog = {read=FOnLog, write=FOnLog};
	__property TProgressEvent OnProgress = {read=FOnProgress,
		write=FOnProgress};
};
//---------------------------------------------------------------------------
#endif
